((8
  (#(make-dll-archive default)
   (4
    lambda
    (oname objects)
    (string-append oname ".a"))
   (3
    lambda
    (oname objects)
    (plan-to
      "ar rc"
      (string-append oname ".a")
      objects)
    (plan-to "ranlib" (string-append oname ".a"))))
  (#(compile-dll-c-file default)
   (4
    lambda
    (file includes defines)
    (change-suffix file ".c" ".o"))
   (3
    lambda
    (file includes defines)
    (plan-to
      "cc"
      "-O"
      "-c"
      includes
      (command-line-defines defines)
      file)))
  (#(make-archive default)
   (4
    lambda
    (oname objects)
    (string-append oname ".a"))
   (3
    lambda
    (oname objects)
    (plan-to
      "ar rc"
      (string-append oname ".a")
      objects)
    (plan-to "ranlib" (string-append oname ".a"))))
  (#(link-c-program default)
   (4 lambda (oname objects libs) oname)
   (3
    lambda
    (oname objects libs)
    (if (file-exists? oname)
      (plan-to
        "mv"
        "-f"
        oname
        (string-append oname "~")))
    (plan-to "cc" "-o" oname objects libs)))
  (#(compile-c-file default)
   (4
    lambda
    (file includes defines)
    (change-suffix file ".c" ".o"))
   (3
    lambda
    (file includes defines)
    (plan-to
      "cc"
      "-O"
      "-c"
      includes
      (command-line-defines defines)
      file)))
  (#(link-c-program aztec)
   (4 lambda (oname objects libs) oname)
   (3
    lambda
    (oname objects libs)
    (plan-to
      "cc"
      "-o"
      oname
      objects
      libs
      "-lma"
      "-lc")))
  (#(compile-c-file aztec)
   (4
    lambda
    (file includes defines)
    (change-suffix file ".c" ".o"))
   (3
    lambda
    (file includes defines)
    (plan-to
      "cc"
      "-dAMIGA"
      includes
      (command-line-defines defines)
      file)))
  (#(link-c-program aix)
   (4 lambda (oname objects libs) oname)
   (3
    lambda
    (oname objects libs)
    (plan-to "cc" "-lansi" "-o" oname objects libs)))
  (#(compile-c-file aix)
   (4
    lambda
    (file includes defines)
    (change-suffix file ".c" ".o"))
   (3
    lambda
    (file includes defines)
    (plan-to
      "cc"
      "-O"
      "-Dunix"
      "-c"
      includes
      (command-line-defines defines)
      file)))
  (#(compile-c-file svr4)
   (4
    lambda
    (file includes defines)
    (change-suffix file ".c" ".o"))
   (3
    lambda
    (file includes defines)
    (plan-to
      "cc"
      "-O"
      "-DSVR4"
      "-c"
      includes
      (command-line-defines defines)
      file)))
  (#(compile-c-file gcc)
   (4
    lambda
    (file includes defines)
    (change-suffix file ".c" ".o"))
   (3
    lambda
    (file includes defines)
    (plan-to
      "gcc"
      "-Wall"
      "-O2"
      "-c"
      includes
      (command-line-defines defines)
      file)))
  (#(link-c-program unicos)
   (4 lambda (oname objects libs) oname)
   (3
    lambda
    (oname objects libs)
    (plan-to
      "cc"
      "setjump.o"
      "-o"
      oname
      objects
      libs)))
  (#(compile-c-file unicos)
   (4
    lambda
    (file includes defines)
    (change-suffix file ".c" ".o"))
   (3
    lambda
    (file includes defines)
    (plan-to
      "cc"
      "-hvector2"
      "-hscalar2"
      "-c"
      includes
      (command-line-defines defines)
      file)))
  (#(make-dll-archive sun)
   (4
    lambda
    (oname objects)
    (string-append oname ".so.1.0"))
   (3
    lambda
    (oname objects)
    (plan-to
      "ld"
      "-assert"
      "pure-text"
      "-o"
      (string-append oname ".so.1.0")
      objects)))
  (#(make-dll-archive hp-ux-9.01)
   (4
    lambda
    (oname objects)
    (string-append oname ".sa"))
   (3
    lambda
    (oname objects)
    (plan-to
      "ld"
      "-b"
      "-o"
      (string-append oname ".sa")
      objects)))
  (#(compile-dll-c-file hp-ux-9.01)
   (4
    lambda
    (file includes defines)
    (change-suffix file ".c" ".o"))
   (3
    lambda
    (file includes defines)
    (plan-to
      "cc"
      "+O1"
      "-Wl,-E"
      "-c"
      includes
      (command-line-defines defines)
      file)))
  (#(compile-c-file hp-ux-9.01)
   (4
    lambda
    (file includes defines)
    (change-suffix file ".c" ".o"))
   (3
    lambda
    (file includes defines)
    (plan-to
      "cc"
      "+O1"
      "-c"
      includes
      (command-line-defines defines)
      file)))
  (#(link-c-program djgpp)
   (4
    lambda
    (oname objects libs)
    (string-append oname ".exe"))
   (3
    lambda
    (oname objects libs)
    (let ((exe (string-append oname ".exe")))
      (plan-to "gcc" "-o" oname objects libs "-lc")
      (plan-to "strip" oname)
      (plan-to "delete" exe)
      (plan-to "aout2exe" oname))))
  (#(link-c-program watcom-9.0)
   (4
    lambda
    (oname objects libs)
    (string-append oname ".exe"))
   (3
    lambda
    (oname objects libs)
    (let ((exe (change-suffix (car objects) ".obj" ".exe"))
          (oexe (string-append oname ".exe")))
      (if (not (string-ci=? exe oexe))
        (plan-to "delete" oexe))
      (plan-to
        "wlinkp"
        "option"
        "quiet"
        "option"
        "stack=40000"
        "FILE"
        (apply string-join
               ","
               (map (lambda (o) (change-suffix o ".obj" ""))
                    objects))
        libs)
      (if (not (string-ci=? exe oexe))
        (plan-to "rename" exe oexe)))))
  (#(compile-c-file watcom-9.0)
   (4
    lambda
    (file includes defines)
    (change-suffix file ".c" ".obj"))
   (3
    lambda
    (file includes defines)
    (plan-to
      "wcc386p"
      "/mf"
      "/d2"
      "/ze"
      "/oxt"
      "/3s"
      "/zq"
      "/w3"
      includes
      (command-line-defines defines)
      file)))
  (#(link-c-program microsoft-c)
   (4
    lambda
    (oname objects libs)
    (string-append oname ".exe"))
   (3
    lambda
    (oname objects libs)
    (let ((exe (change-suffix (car objects) ".obj" ".exe"))
          (oexe (string-append oname ".exe")))
      (if (not (string-ci=? exe oexe))
        (plan-to "delete" oexe))
      (plan-to
        "link"
        "/noe"
        "/ST:40000"
        (apply string-join
               "+"
               (map (lambda (o) (change-suffix o ".obj" ""))
                    objects))
        libs)
      (if (not (string-ci=? exe oexe))
        (plan-to "rename" exe oexe)))))
  (#(compile-c-file microsoft-c)
   (4
    lambda
    (file includes defines)
    (change-suffix file ".c" ".obj"))
   (3
    lambda
    (file includes defines)
    (plan-to
      "cl"
      "-c"
      "Oxp"
      "-AH"
      includes
      (command-line-defines defines)
      file)))
  (#(link-c-program turbo-c-2)
   (4
    lambda
    (oname objects libs)
    (string-append oname ".exe"))
   (3
    lambda
    (oname objects libs)
    (let ((exe (change-suffix (car objects) ".obj" ".exe"))
          (oexe (string-append oname ".exe")))
      (if (not (string-ci=? exe oexe))
        (plan-to "delete" oexe))
      (plan-to "tcc" objects "-Lc:	urboclib" libs)
      (if (not (string-ci=? exe oexe))
        (plan-to "rename" exe oexe)))))
  (#(compile-c-file turbo-c-2)
   (4
    lambda
    (file includes defines)
    (change-suffix file ".c" ".obj"))
   (3
    lambda
    (file includes defines)
    (plan-to
      "tcc"
      "-c"
      "-d"
      "-O"
      "-Z"
      "-G"
      "-ml"
      "-c"
      "-Ic:\\turboc\\include"
      includes
      (command-line-defines defines)
      file)))
  (#(link-c-program borland-c-3.1)
   (4
    lambda
    (oname objects libs)
    (string-append oname ".exe"))
   (3
    lambda
    (oname objects libs)
    (let ((exe (change-suffix (car objects) ".obj" ".exe"))
          (oexe (string-append oname ".exe")))
      (if (not (string-ci=? exe oexe))
        (plan-to "delete" oexe))
      (plan-to "bcc" "-ml" objects libs)
      (if (not (string-ci=? exe oexe))
        (plan-to "rename" exe oexe)))))
  (#(compile-c-file borland-c-3.1)
   (4
    lambda
    (file includes defines)
    (change-suffix file ".c" ".obj"))
   (3
    lambda
    (file includes defines)
    (plan-to
      "bcc"
      "-d"
      "-O"
      "-Z"
      "-G"
      "-w-pro"
      "-ml"
      "-c"
      (if (member '("FLOATS") defines) "" "-f-")
      includes
      (command-line-defines defines)
      file))))
 (7
  (4
   (5 . expression)
   (4 . #f)
   (3 . result-name)
   (2 . #f))
  (3
   (5 . expression)
   (4 . #f)
   (3 . procedure)
   (2 . #f))
  (2 (5 . symbol) (4 . #f) (3 . platform) (2 . #t))
  (1 (5 . symbol) (4 . #f) (3 . name) (2 . #t)))
 (6
  (#(windows borland-c-3.1)
   (5 . "")
   (4 . "-W")
   (3 . "-N -W"))
  (#(m borland-c-3.1) (5 . "") (4 . "") (3 . ""))
  (#(dlll sun)
   (5 . #f)
   (4 . "-ldl")
   (3 . "-DSUN_DL"))
  (#(m sun) (5 . "") (4 . "-lm") (3 . ""))
  (#(curses linux)
   (5 . "/usr/lib/libncurses.a")
   (4 . "-lncurses")
   (3 . "-I/usr/include/ncurses"))
  (#(dlll linux)
   (5 . #f)
   (4 . "-ldld")
   (3 . "-DDLD -DDLD_DYNCM"))
  (#(c linux)
   (5 . "/usr/lib/libc.sa")
   (4 . "-lc")
   (3 . ""))
  (#(m linux)
   (5 . "/usr/lib/libm.sa")
   (4 . "-lm")
   (3 . ""))
  (#(x11 default)
   (5 . "/usr/X11/lib/libX11.a")
   (4 . "-lX11")
   (3 . "-I/usr/local/X11R5/include -DX11"))
  (#(curses default)
   (5 . "/usr/lib/libcurses.a")
   (4 . "-lcurses")
   (3 . ""))
  (#(regex default)
   (5 . "/usr/lib/librgx.a")
   (4 . "-lrgx")
   (3 . ""))
  (#(c default)
   (5 . "/usr/lib/libc.a")
   (4 . "-lc")
   (3 . ""))
  (#(m default)
   (5 . "/usr/lib/libm.a")
   (4 . "-lm")
   (3 . "")))
 (5
  (5
   (5 . optstring)
   (4 . #f)
   (3 . lib-path)
   (2 . #f))
  (4
   (5 . string)
   (4 . #f)
   (3 . link-lib-flag)
   (2 . #f))
  (3
   (5 . string)
   (4 . #f)
   (3 . compiler-flags)
   (2 . #f))
  (2 (5 . symbol) (4 . #f) (3 . platform) (2 . #t))
  (1 (5 . symbol) (4 . #f) (3 . library) (2 . #t)))
 (4
  (optstring
    (5 . #f)
    (4 . string)
    (3 lambda (x) (or (not x) (string? x)))
    (2 . optstring))
  (domain
    (5 . #f)
    (4 . atom)
    (3 . #f)
    (2 . domain))
  (string
    (5 . #f)
    (4 . string)
    (3 . string?)
    (2 . string))
  (symbol
    (5 . #f)
    (4 . symbol)
    (3 . symbol?)
    (2 . symbol))
  (boolean
    (5 . #f)
    (4 . boolean)
    (3 . boolean?)
    (2 . boolean))
  (expression
    (5 . #f)
    (4 . expression)
    (3 . #f)
    (2 . expression))
  (uint (5 . #f)
        (4 . integer)
        (3
         lambda
         (x)
         (and (number? x)
              (integer? x)
              (not (negative? x))))
        (2 . uint))
  (base-id
    (5 . #f)
    (4 . base-id)
    (3 lambda (x) (or (symbol? x) (number? x)))
    (2 . base-id))
  (type (5 . #f)
        (4 . symbol)
        (3 . base:supported-type?)
        (2 . type))
  (atom (5 . #f)
        (4 . atom)
        (3 lambda (x) (or (symbol? x) (number? x)))
        (2 . atom)))
 (3
  (6
   (5 . expression)
   (4 . #f)
   (3 . view-procedure)
   (2 . #f))
  (5
   (5 . expression)
   (4 . #f)
   (3 . user-integrity-rule)
   (2 . #f))
  (4
   (5 . base-id)
   (4 . #f)
   (3 . bastab-id)
   (2 . #f))
  (3
   (5 . atom)
   (4 . #f)
   (3 . coltab-name)
   (2 . #f))
  (2
   (5 . uint)
   (4 . #f)
   (3 . column-limit)
   (2 . #f))
  (1 (5 . atom) (4 . #f) (3 . table-name) (2 . #t)))
 (2
  (5
   (5 . expression)
   (4 . #f)
   (3 . type-param)
   (2 . #f))
  (4 (5 . type) (4 . #f) (3 . type-id) (2 . #f))
  (3
   (5 . expression)
   (4 . #f)
   (3 . domain-integrity-rule)
   (2 . #f))
  (2
   (5 . symbol)
   (4 . #f)
   (3 . domain-name)
   (2 . #f))
  (1 (5 . atom) (4 . #f) (3 . domain-id) (2 . #t)))
 (1
  (5
   (5 . domain)
   (4 . #f)
   (3 . domain-id)
   (2 . #f))
  (4
   (5 . expression)
   (4 . #f)
   (3 . column-integrity-rule)
   (2 . #f))
  (3
   (5 . symbol)
   (4 . #f)
   (3 . column-name)
   (2 . #f))
  (2
   (5 . boolean)
   (4 . #f)
   (3 . primary-key?)
   (2 . #f))
  (1
   (5 . uint)
   (4 . #f)
   (3 . column-number)
   (2 . #t)))
 (0
  (system-commands
    (6 . #f)
    (5 . #f)
    (4 . 8)
    (3 . desc:system-commands)
    (2 . 4))
  (desc:system-commands
    (6 . #f)
    (5 . #f)
    (4 . 7)
    (3 . *columns*)
    (2 . 5))
  (c-libraries
    (6 . #f)
    (5 . #f)
    (4 . 6)
    (3 . desc:c-libraries)
    (2 . 5))
  (desc:c-libraries
    (6 . #f)
    (5 . #f)
    (4 . 5)
    (3 . *columns*)
    (2 . 5))
  (*columns*
    (6 . #f)
    (5 . #f)
    (4 . 1)
    (3 . *columns*)
    (2 . 5))
  (*domains-data*
    (6 . #f)
    (5 . #f)
    (4 . 4)
    (3 . *domains-desc*)
    (2 . 5))
  (*catalog-data*
    (6 . #f)
    (5 . #f)
    (4 . 0)
    (3 . *catalog-desc*)
    (2 . 6))
  (*domains-desc*
    (6 . #f)
    (5 . #f)
    (4 . 2)
    (3 . *columns*)
    (2 . 5))
  (*catalog-desc*
    (6 . #f)
    (5 . #f)
    (4 . 3)
    (3 . *columns*)
    (2 . 5)))
 (*base-resources* (free-id (2 . 9))))
